/*
   ----------------------------------------------------------------------------
	TestDeleteRow.prg
   A sample dBL program from 
   The dBASE Book Plus by Kenneth J. Mayer. 
   Program copyright 2015. 
   Permission is granted for use as a learning tool for dBASE Plus.
   Sample from: Chapter 4
	
   This program was put together with the sole purpose of testing the 
	method DeleteRow in the datamodule used in the sample code. It is here as
	a separate program to show how this works.
	----------------------------------------------------------------------------
*/
clear

// add an Invoice row we can then delete ...
aMyData = new array(1,2)
aMyData[1,1] = "InvoiceNumber"
aMyData[1,2] = GetNextKey( "InvNum_Seq" )
aMyData.grow(1)
aMyData[2,1] = "InvoiceDate"
aMyData[2,2] = date()
aMyData.grow(1)
aMyData[3,1] = "CustomerNumber"
aMyData[3,2] = 3
? "New Invoice added"
set procedure to DataLayer.dmd
oDMD = new DataLayerDataModule()
oDMD.addRow( "Invoices", aMyData )

// need to get the Invoice Number:
oDMD.Invoices.requery() // important to get current last row
oDMD.Invoices.rowset.last()
nInvoiceNum = oDMD.Invoices.rowset.fields["InvoiceNumber"].value
? "Invoice Number: "+nInvoiceNum

// add a LineItem row we can then delete ...
aMyData = new array(1,2)
aMyData[1,1] = "LineItemNumber"
aMyData[1,2] = GetNextKey( "LINum_Seq" )
? "LineItemNumber: "+aMyData[1,2]
aMyData.grow(1)
aMyData[2,1] = "InvoiceNumber"
aMyData[2,2] = nInvoiceNum
aMyData.grow(1)
aMyData[3,1] = "ItemNumber"
aMyData[3,2] = 5
aMyData.grow(1)
aMyData[4,1] = "Quantity"
aMyData[4,2] = 3
aMyData.grow(1)
aMyData[5,1] = "CostPerItem"
aMyData[5,2] = 12.50

// add row to LineItems:
oDMD.addRow( "LineItems", aMyData )
oDMD.LineItems.requery() // be sure we have this
? "Line Item Added"

// Now to see if we can delete 'em.
oDMD.DeleteRow( "Invoices", "InvoiceNumber", nInvoiceNum, true, "LineItems", "InvoiceNumber" )
? "Data Deleted"

// cleanup:
release object oDMD
oDMD := null
close procedure DataLayer.dmd

function GetNextKey( cGenName )
   /*
	   Function to generate next key value
		for a Firebird Sequence (created by
		Mervyn Bick)
	*/
   private dGen, qGen, nVal, cCmd
	dGen = new ADODatabase()
	dGen.databaseName := "BookSample_ADO_RO"
	dGen.loginString  := "SYSDBA/masterkey"
	dGen.active       := true
	
	qGen = new ADOQuery()
	qGen.database    := dGen
	cCmd = "Select Gen_ID("+cGenName+",1) from MyGen" 
	qGen.sql          = cCmd
	qGen.requestLive := false
	qGen.active      := true
	qGen.rowset.first()
	
	// next key value:
	nVal = qGen.rowset.fields[1].value 
	
   // deactivate:	
	qGen.active := false
	dGen.active := false
return nVal